      SUBROUTINE EF04R(M,N,A,F,DELTA,P,NG,V1,V2,MU,H,UP,U,B)
         INTEGER M,MU,N,NG
         REAL A,B,DELTA,F,H,P,U,UP,V1,V2
         DIMENSION A(M,N),B(1),DELTA(M),F(M),H(N),MU(N),U(N),UP(N),
     1             V1(N),V2(N)
         EXTERNAL AVZ2R,IA20R
         INTEGER I,I1,I2,I3,IM,IP,IS,ISP,IXP,J,K,K1,K2,K3,K4,K5,KN,L,
     1           NP
         REAL AVZ2R,E,R,S,W,W1
         DATA E/1.E-5/,ISP/20/
       K = M + M
       K1 = K + M
       K2 = K1 + N
       K3 = K2 + N
       K4 = K3 + N
       K5 = K4 + N + 1
       H(N) = 0.
       W = 0.
       DO 10 J = 1, N
          I1 = K3 + J
          I2 = K4 + J
          I3 = K5 + J
          W1 = W + 0.5*H(J)
          B(I1) = 1./W1
          B(I2) = 0.
          B(I3) = W1
          W = 0.5*H(J)
   10  CONTINUE
       B(K5) = 0.
       DO 30 I = 1, M
          B(I) = 0.
          DO 20 J = 1, N
             I3 = K5 + J
             A(I,J) = A(I,J)*B(I3)
             B(I) = B(I) + A(I,J)*A(I,J)
   20     CONTINUE
   30  CONTINUE
   40  CONTINUE
       DO 50 J = 1, N
          U(J) = UP(J)
   50  CONTINUE
       IS = 0
   60  CONTINUE
       IP = 0
   70  CONTINUE
       L = 1
   80  CONTINUE
       NP = 1
       DO 100 I = 1, M
          I1 = M + I
          B(I1) = 0.
          DO 90 J = 1, N
             B(I1) = B(I1) + A(I,J)*U(J)
   90     CONTINUE
  100  CONTINUE
       DO 140 I = 1, M
          I1 = K + I
          I2 = M + I
          B(I1) = ABS(B(I2) - F(I)) - DELTA(I)
          IF (B(I1) - 1.E-4*DELTA(I)) 130, 130, 110
  110     CONTINUE
          W = SQRT(B(I))
          B(I1) = B(I1)/W
          W1 = 0.1*DELTA(I)/W
          IF (B(I1) - W1) 140, 140, 120
  120     CONTINUE
          NP = 2
          GO TO 140
  130     CONTINUE
          B(I1) = 0.
  140  CONTINUE
       GO TO (150,190),NP
  150  CONTINUE
       IF (NG) 160, 360, 160
  160  CONTINUE
       GO TO (170,360),L
  170  CONTINUE
       L = 2
       DO 180 J = 1, N
          I1 = K2 + J
          B(I1) = U(J)
  180  CONTINUE
       CALL IA20R(N,B(K2+1),NG,V1,V2,MU,H,B(K3+1),B(K4+1),E,ISP,0,U,
     1            W,KN,B(K5+1))
       GO TO 80
  190  CONTINUE
       IF (IS - N) 220, 220, 200
  200  CONTINUE
       DO 210 I = 1, M
          DELTA(I) = DELTA(I) + P*DELTA(I)
  210  CONTINUE
       GO TO 40
  220  CONTINUE
       R = AVZ2R(B(K+1),M,1,IM)
       IM = IM
  230  CONTINUE
       I1 = M + IM
       W = B(I1) - F(IM)
       S = R*SIGN(1.,W)/SQRT(B(IM))
       DO 240 J = 1, N
          U(J) = U(J) - S*A(IM,J)
  240  CONTINUE
       IP = IP + 1
       GO TO (250,270,330),IP
  250  CONTINUE
       IXP = IM
       DO 260 J = 1, N
          I1 = K1 + J
          B(I1) = U(J)
  260  CONTINUE
       GO TO 70
  270  CONTINUE
       R = 0.
       DO 280 J = 1, N
          R = R + A(IXP,J)*U(J)
  280  CONTINUE
       I1 = M + IXP
       B(I1) = R
       W = ABS(R-F(IXP)) - DELTA(IXP)
       IF (W - 1.E-4*DELTA(IXP)) 290, 290, 300
  290  CONTINUE
       R = 0.
       GO TO 310
  300  CONTINUE
       R = W/SQRT(B(IXP))
  310  CONTINUE
       IM = IXP
       DO 320 J = 1, N
          I2 = K2 + J
          B(I2) = U(J)
  320  CONTINUE
       GO TO 230
  330  CONTINUE
       R = 0.
       W = 0.
       DO 340 J = 1, N
          I1 = K1 + J
          I2 = K2 + J
          S = B(I1) - B(I2)
          R = R + S*S
          W = W + S*(B(I1) - U(J))
  340  CONTINUE
       W = R/W
       DO 350 J = 1, N
          I1 = K1 + J
          U(J) = B(I1) + W*(U(J) - B(I1))
  350  CONTINUE
       IS = IS + 1
       GO TO 60
  360  CONTINUE
       RETURN
      END
